#include "nds.hh"
#include "nds_helper.hh"

#include <memory>
#include <cassert>
#include <cstdlib>
#include <iostream>
#include <sstream>
#include <string>

#include "nds_testing.hh"

int main(int argc, char *argv[])
{
    using NDS::connection;

    //---------------------------------------------------------------------
    // Obtain the port of the server
    //---------------------------------------------------------------------
    connection::port_type	port = 31200;
    if ( ::getenv("NDS_TEST_PORT") )
    {
        std::istringstream	ps( ::getenv("NDS_TEST_PORT") );

        ps >> port;
    }

    std::string hostname("localhost");
    if ( ::getenv("NDS_TEST_HOST") )
    {
        hostname = ::getenv( "NDS_TEST_HOST" );
    }

    std::cerr << "Connecting to " << hostname << ":" << port << std::endl;
    pointer< connection > conn( new connection( hostname, port, connection::PROTOCOL_ONE ));

    connection::channel_names_type ch;
    ch.push_back("X1:PEM-1");
    try
    {
        conn->iterate(0, 1, ch);
        while( true )
        {
            NDS::buffers_type bufs = conn->next();
        }
    }
    catch( const std::out_of_range& /* Error */)
    {
        return 0;
        // Reached end of buffers so just do nothing
    }

    return 1;
}